Attribute VB_Name = "modDeclares"
Option Explicit

Public Terminal() As String
Public TerminalLines As Byte

'Going to use dynamic arrays. If error occurs adding, game server/user will not be added to database, but play ok
'Public Const MAX_SERVERS = 128 '255 'Maximum game servers (zones) that can be connected to the biller
'Public Const MAX_USERS = 512 '1024 '512 'Maximum users that this biller will be able to hold for each connected game server

'One player's complete data block (logged in players)
Public Type UserTYPES
 Name As String ' * L_Name 'User's name
 MacID As Long 'Stored machine ID
 IP As Long 'Stored IP
 UserID As Long 'Continuum's Index of a player. In this app, it's classfied as an ID
 Channels As String ' * 128 'Chat channels
 MessageOp As Boolean
 AccountOp As Boolean
 SysOp As Boolean

 UserDatabaseIndex As Long 'Where in User Database is the record for this logged in player

 ScoreSwap As String 'with what one of your names to swap scores when exiting zone
End Type

'One game server's complete data block
Public Type ServerTYPES
 MessagesSentCount As Long 'a number identifying a sent message; required

 Name As String ' * 126 'Zone name
 Port As Integer 'since we cannot get right port from sock.sin_port even with ntohs() function for some reason, we gotta get it this way
 Sock As sockaddrTYPES 'How I tell one from the other

' User(1 To MAX_USERS) As UserTYPES 'currently logged in players for each zone
 User() As UserTYPES 'currently logged in players for each zone
 TotalUsers As Long 'Total number of players logged in

 ServerID As Long 'from server.ini; from which User Database it will use user names
 GroupID As Long 'from server.ini; from which Squad Database it will use squad
 ScoreID As Long 'from server.ini; from which Score Database it will use score

 UserDatabase As String
 UserDatabaseRecords As Long
 SquadDatabase As String
 SquadDatabaseRecords As Long
 ScoreDatabase As String
 ScoreDatabaseRecords As Long
End Type
'Public Server(1 To MAX_SERVERS) As ServerTYPES 'Connected servers
Public Server() As ServerTYPES 'Connected servers
Public TotalServers As Long 'Total connected servers

Public Sock As sockaddrTYPES 'Variables of open connection to the internet by this biller
Public SockID As Long

Public Port As Integer 'The port to which local/remote game servers will be connecting. no need for ip
Public AllowNewUsers As Boolean 'can stop adding of new users to database
Public AskNewUsers As Boolean
Public AllowNewZones As Boolean

Public LogTerminal As Boolean

Public Greeting As String

Public AutoSave As Date
Public LastAutoSave As Date

Private L As Long

Public Sub ReadDatabases(ServerIndex As Long)
On Error GoTo ErrHandler
With Server(ServerIndex)
ChDrive App.Path: ChDir App.Path
Open "User." + CStr(.ServerID) For Binary As #1
 .UserDatabaseRecords = LOF(1) / U_Length
 .UserDatabase = Space(U_Length * .UserDatabaseRecords)
 Get #1, 1, .UserDatabase
Close 1
Open "Squad." + CStr(.GroupID) For Binary As #1
 .SquadDatabaseRecords = LOF(1) / S_Length
 .SquadDatabase = Space(S_Length * .SquadDatabaseRecords)
 Get #1, 1, .SquadDatabase
Close 1
Open "Score." + CStr(.ScoreID) For Binary As #1
 .ScoreDatabaseRecords = LOF(1) / L_Score
 .ScoreDatabase = Space(L_Score * .ScoreDatabaseRecords)
 Get #1, 1, .ScoreDatabase
Close 1
AddTerminal .Name & " Loaded: " & .UserDatabaseRecords & " User Database records " & .SquadDatabaseRecords & " Squad Database records " & .ScoreDatabaseRecords & " Score Database records"
ErrHandler:
Close 1
End With
End Sub

Public Sub WriteDatabases(ServerIndex As Long)
On Error Resume Next
With Server(ServerIndex)
ChDrive App.Path: ChDir App.Path
Kill "User." + CStr(.ServerID)
Open "User." + CStr(.ServerID) For Binary As #1
 Put #1, 1, .UserDatabase
Close 1
Kill "Squad." + CStr(.GroupID)
Open "Squad." + CStr(.GroupID) For Binary As #1
 Put #1, 1, .SquadDatabase
Close 1
Kill "Score." + CStr(.ScoreID)
Open "Score." + CStr(.ScoreID) For Binary As #1
 Put #1, 1, .ScoreDatabase
Close 1
AddTerminal .Name & " Written: " & .UserDatabaseRecords & " User Database records " & .SquadDatabaseRecords & " Squad Database records " & .ScoreDatabaseRecords & " Score Database records"
End With
End Sub

'Add a new server to the server list
Public Sub LoginServer(TempSock As sockaddrTYPES, Name As String, Port As String, ServerID As String, GroupID As String, ScoreID As String)
'If TotalServers = MAX_SERVERS Then Exit Sub
TotalServers = TotalServers + 1
On Error Resume Next
ReDim Preserve Server(1 To TotalServers)
If Err > 0 Then 'ran out of memory :(
 TotalServers = TotalServers - 1
' UDPSend TempSock, Chr(0) + Chr(7)
' AddTerminal Err.Description & " " & Err & ". Zone booted"
 AddTerminal Err.Description & " " & Err & ". Zone will not be able to use biller services"
 Exit Sub
End If
Server(TotalServers).MessagesSentCount = 0
Server(TotalServers).Name = TrimZero(Name)
Server(TotalServers).Port = GetInteger(Port)
Server(TotalServers).TotalUsers = 0
Server(TotalServers).Sock = TempSock
Server(TotalServers).ServerID = GetLong(ServerID)
Server(TotalServers).GroupID = GetLong(GroupID)
Server(TotalServers).ScoreID = GetLong(ScoreID)
ReadDatabases TotalServers
End Sub

'Remove a server by pushing the server values down one
Public Sub LogoffServer(ServerIndex As Long)
UDPSend Server(ServerIndex).Sock, Chr(0) + Chr(7)
WriteDatabases ServerIndex

For L = ServerIndex To TotalServers - 1
 Server(L) = Server(L + 1)
Next
TotalServers = TotalServers - 1
On Error Resume Next
ReDim Preserve Server(1 To TotalServers)
End Sub

'Add a new user to the given server
Public Sub LoginUser(ServerIndex As Long, Name As String, MacID As String, IP As String, UserID As String, UserDatabaseIndex As Long)
Dim s As String, I As Integer
With Server(ServerIndex)
'If .TotalUsers = MAX_USERS Then Exit Sub
.TotalUsers = .TotalUsers + 1
On Error Resume Next
ReDim Preserve .User(1 To .TotalUsers)
If Err > 0 Then 'ran out of memory :(
 .TotalUsers = .TotalUsers - 1
' UDPSend .Sock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(2) + UserID + String(197 - 12, Chr(0))
' AddTerminal Err.Description & " " & Err & ". User booted"
 AddTerminal Err.Description & " " & Err & ". User will not be added to User Database"
 Exit Sub
End If
End With

PutUserDatabaseRecordField ServerIndex, UserDatabaseIndex, U_IP, IP 'update user's ip cause it changes
PutUserDatabaseRecordField ServerIndex, UserDatabaseIndex, U_LastDatePlayed, GetDateString 'and date he entered zone again

With Server(ServerIndex).User(Server(ServerIndex).TotalUsers)
.UserDatabaseIndex = UserDatabaseIndex 'The records in User Database are fixed length and are stored in 1 string, 1 after the other
.UserID = GetLong(UserID)
'add our biller greeting message
s = Greeting
I = InStr(LCase(s), "[default]")
If I > 0 Then s = Left(s, I - 1) + "Greetings. This is " & App.Title & ". Type ?bhelp for biller commands" + Mid(s, I + 8 + 1)
If s > "" Then
 frmTerminal.tmrDELAYEDResponses.Enabled = 0 'reset it to ensure player gets the greeting
 frmTerminal.tmrDELAYEDResponses.Enabled = 1
 frmTerminal.tmrDELAYEDResponses.Tag = frmTerminal.tmrDELAYEDResponses.Tag & Format(ServerIndex, "0000000000") & Format(.UserID, "0000000000") & s & Chr(0)
End If
.Name = Name
.IP = GetLong(IP)
.MacID = GetLong(MacID)
.Channels = ""
.MessageOp = 0
.AccountOp = 0
.SysOp = 0
.ScoreSwap = "" 'with what other name does a player want to swap scores when exiting zone
End With
End Sub

'Remove a user by pushing the user values down by one
Public Sub LogoffUser(ServerIndex As Long, UserIndex As Long)
With Server(ServerIndex)
For L = UserIndex To .TotalUsers - 1
 .User(L) = .User(L + 1)
Next
.TotalUsers = .TotalUsers - 1
On Error Resume Next
ReDim Preserve .User(1 To .TotalUsers)
End With
End Sub

'Does our index of logged in players match one of continuum's
Public Function GetUserIndex(ServerIndex As Long, UserID As Long) As Long
For L = 1 To Server(ServerIndex).TotalUsers
 If Server(ServerIndex).User(L).UserID = UserID Then GetUserIndex = L: Exit Function
Next
End Function

'Since the subgame doesn't allow duplicate player names, we'll make em different by adding spaces at end
Public Function GetUserIndex2(ServerIndex As Long, ByVal Name As String) As Long
Name = LCase(Name)
For L = 1 To Server(ServerIndex).TotalUsers
 If LCase(Server(ServerIndex).User(L).Name) = Name Then GetUserIndex2 = L: Exit Function
Next
End Function

Public Function GetServerIndex(TempSock As sockaddrTYPES) As Long
For L = 1 To TotalServers
 If Server(L).Sock.sin_addr = TempSock.sin_addr And Server(L).Sock.sin_port = TempSock.sin_port Then GetServerIndex = L: Exit Function
Next
End Function
