Attribute VB_Name = "modSquadDatabase"
Option Explicit
         
'Squad Database is made of 1 string that is divided in record of fixed lengths (B_Length). Those records have the fields which offsets are below
Public Const S_Name = 0 'Squad name
Public Const S_Password = 24 'Squad password
Public Const S_OwnerIndex = 48 'Squad owner (by User Database index)
Public Const S_Length = 52 'Length of 1 SquadDatabase record

'and lengths...
Public Const LS_Name = 24
Public Const LS_Password = 24 'Squad password
Private Const LS_OwnerIndex = 4

'Retreive one full Squad information block
Private Function GetSquadDatabaseRecord(ServerIndex As Long, SquadDatabaseIndex As Long) As String
If SquadDatabaseIndex < 1 Then Exit Function 'trying to get player's squad from a player who is not in any squad
With Server(ServerIndex)
If SquadDatabaseIndex > .SquadDatabaseRecords Then Exit Function 'Squad Database got manually edited and had a record deleted. Now the SquadIndex in UserDatabase is pointing to squad that is out of bounds
GetSquadDatabaseRecord = Mid(.SquadDatabase, (SquadDatabaseIndex - 1) * S_Length + 1, S_Length)
End With
End Function

'Write a Squad information block to disk
Public Sub PutSquadDatabaseRecord(ServerIndex As Long, SquadDatabaseIndex As Long, SquadDatabaseRecord As String)
If SquadDatabaseIndex < 1 Then Exit Sub
With Server(ServerIndex)
If SquadDatabaseIndex > .SquadDatabaseRecords Then Exit Sub
.SquadDatabase = Left(.SquadDatabase, (SquadDatabaseIndex - 1) * S_Length) + SquadDatabaseRecord + Mid(.SquadDatabase, SquadDatabaseIndex * S_Length + 1)
End With
End Sub

'Intended to be used ONCE during login for the SquadID parameter
Public Function GetSquadDatabaseIndex(ServerIndex As Long, Name As String) As Long
Dim L As Long, s As String
s = LCase(FillZero(Name, LS_Name))
With Server(ServerIndex)
For L = 1 To .SquadDatabaseRecords
 If LCase(Mid(GetSquadDatabaseRecord(ServerIndex, L), S_Name + 1, LS_Name)) = s Then GetSquadDatabaseIndex = L: Exit Function
Next
End With
End Function

Public Function GetSquadDatabaseRecordField(ServerIndex As Long, SquadDatabaseIndex As Long, Field As Integer) As String
Dim s As String
s = GetSquadDatabaseRecord(ServerIndex, SquadDatabaseIndex)
Select Case Field
Case S_Name: GetSquadDatabaseRecordField = Mid(s, S_Name + 1, LS_Name)
Case S_Password: GetSquadDatabaseRecordField = Mid(s, S_Password + 1, LS_Password)
Case S_OwnerIndex: GetSquadDatabaseRecordField = Mid(s, S_OwnerIndex + 1, LS_OwnerIndex)
End Select
End Function

Public Sub PutSquadDatabaseRecordField(ServerIndex As Long, SquadDatabaseIndex As Long, Field As Integer, FieldValue As String)
Dim s As String
s = GetSquadDatabaseRecord(ServerIndex, SquadDatabaseIndex)
Select Case Field
Case S_Name: s = FillZero(FieldValue, LS_Name) + Mid(s, S_Name + LS_Name + 1)
Case S_Password: s = Left(s, S_Password) + FillZero(FieldValue, LS_Password) + Mid(s, S_Password + LS_Password + 1)
Case S_OwnerIndex: s = Left(s, S_OwnerIndex) + FieldValue + Mid(s, S_OwnerIndex + LS_OwnerIndex + 1)
End Select
PutSquadDatabaseRecord ServerIndex, SquadDatabaseIndex, s
End Sub
