Attribute VB_Name = "modUserDatabase"
Option Explicit

'User Database is made of 1 string that is divided in record of fixed lengths (B_Length). Those records have the fields which offsets are below
Public Const U_Name = 0 'Player name
Public Const U_SquadIndex = 24 'Index to Squad Database
Public Const U_ScoreIndex = 28 'Index to Score Database
Public Const U_Banner = 32
Public Const U_CreateDateTime = 128 'Creation date&time
Public Const U_IP = 140 'Last IP Address he logged in under
Public Const U_MacID = 144
Public Const U_LastDatePlayed = 148 'Date of last time playing. Not used in game packets, just kept track of in User/Ban Database
Public Const U_TotalSeconds = 152 'Total seconds he spent logged in
Public Const U_Length = 156 'Length of 1 UserDatabase record

'and lengths...
Public Const L_Name = 24 'Player name
Public Const LU_SquadIndex = 4 'index to Squad Database
Public Const LU_ScoreIndex = 4
Public Const L_Banner = 96
Private Const L_CreateDateTime = 12 'Creation date
Public Const L_IP = 4 'Last IP Address he logged in under
Public Const L_MacID = 4 'Last Machine ID he used
Private Const L_LastDatePlayed = 4 'Date of last time playing
Public Const LU_TotalSeconds = 4 'Total seconds he spent logged in

'Retreive one full player information block
Private Function GetUserDatabaseRecord(ServerIndex As Long, UserDatabaseIndex As Long) As String
If UserDatabaseIndex < 1 Then Exit Function 'server().users().userdatabaseindex is set to 0 when deleting own record with ?scoredelete. user will then get kicked and 'player quit' packet will be received. this will stop score writing to wrong user
With Server(ServerIndex)
If UserDatabaseIndex > .UserDatabaseRecords Then Exit Function 'User Database got manually edited and had a record deleted. Now the OwnerIndex in SquadDatabase is pointing to owner that is out of bounds
GetUserDatabaseRecord = Mid(.UserDatabase, (UserDatabaseIndex - 1) * U_Length + 1, U_Length)
End With
End Function

'Write a player information block to disk
Private Sub PutUserDatabaseRecord(ServerIndex As Long, UserDatabaseIndex As Long, UserDatabaseRecord As String)
If UserDatabaseIndex < 1 Then Exit Sub 'server().users().userdatabaseindex is set to 0 when deleting own record with ?scoredelete. user will then get kicked and 'player quit' packet will be received. this will stop score writing to wrong user
With Server(ServerIndex)
If UserDatabaseIndex > .UserDatabaseRecords Then Exit Sub 'User Database got manually edited and had a record deleted. Now the OwnerIndex in SquadDatabase is pointing to owner that is out of bounds
.UserDatabase = Left(.UserDatabase, (UserDatabaseIndex - 1) * U_Length) + UserDatabaseRecord + Mid(.UserDatabase, UserDatabaseIndex * U_Length + 1)
End With
End Sub

Public Function GetUserDatabaseIndex(ServerIndex As Long, Name As String, MacID As String) As Long
Dim l As Long, s As String
s = LCase(FillZero(Name, L_Name))
With Server(ServerIndex)
For l = 1 To .UserDatabaseRecords
 If LCase(Mid(GetUserDatabaseRecord(ServerIndex, l), U_Name + 1, L_Name)) = s And Mid(GetUserDatabaseRecord(ServerIndex, l), U_MacID + 1, L_MacID) = MacID Then GetUserDatabaseIndex = l: Exit Function
Next
End With
End Function

'Add a player to the end of the database and increment the UserDatabaseRecords on disk and memory by one
Public Sub CreateUserDatabaseRecord(ServerIndex As Long, UserDatabaseRecords As Long, Name As String, IP As String, MacID As String)
Dim l As Long
With Server(ServerIndex)
.UserDatabaseRecords = .UserDatabaseRecords + 1
CreateScoreDatabaseRecord ServerIndex, l
PutUserDatabaseRecord ServerIndex, .UserDatabaseRecords, FillZero(Name, L_Name) + String(LU_SquadIndex, Chr(0)) + GetStringL(l) + String(L_Banner, Chr(0)) + GetDateTimeString + IP + MacID + GetDateString + String(LU_TotalSeconds, Chr(0))
UserDatabaseRecords = .UserDatabaseRecords
End With
End Sub

'Match an alias with the given info
Public Function GetAliases(ServerIndex As Long, MacID As Long) As String
Dim l As Long, s As String, s2 As String

With Server(ServerIndex)
For l = 1 To .UserDatabaseRecords
 s2 = GetUserDatabaseRecord(ServerIndex, l)
 If GetLong(Mid(s2, U_MacID + 1, L_MacID)) = MacID Then s = s + TrimZero(Mid(s2, U_Name + 1, L_Name)) + ", "
Next
End With
GetAliases = Left(s, Len(s) + 2 * (s > ""))
End Function

'Get aliases of only players that have used more than 1
Function GetAliasesX2(ServerIndex As Long) As String
Dim s As String, s2 As String, s3 As String, l As Long, L2 As Long, foundmorethan1 As Boolean

With Server(ServerIndex)
For l = 1 To .UserDatabaseRecords
 s2 = GetUserDatabaseRecord(ServerIndex, l)
 If InStr(s, TrimZero(Mid(s2, U_Name + 1, L_Name))) = 0 Then
  foundmorethan1 = 0
  For L2 = l + 1 To .UserDatabaseRecords
   s3 = GetUserDatabaseRecord(ServerIndex, L2)
   If Mid(s3, U_MacID + 1, L_MacID) = Mid(s2, U_MacID + 1, L_MacID) Or Mid(s3, U_IP + 1, L_IP) = Mid(s2, U_IP + 1, L_IP) Then
    If Not foundmorethan1 Then s = s + "<" + TrimZero(Mid(s2, U_Name + 1, L_Name)) + ">"
    s = s + "<" + TrimZero(Mid(s3, U_Name + 1, L_Name)) + ">"
    foundmorethan1 = 1
   End If
  Next
  If foundmorethan1 Then s = s + ","
 End If
Next
End With
GetAliasesX2 = Left(s, Len(s) + (s > ""))
End Function

Public Function GetUserDatabaseRecordField(ServerIndex As Long, UserDatabaseIndex As Long, Field As Integer) As String
Dim s As String
s = GetUserDatabaseRecord(ServerIndex, UserDatabaseIndex)
Select Case Field
Case U_Name: GetUserDatabaseRecordField = Mid(s, U_Name + 1, L_Name)
Case U_SquadIndex: GetUserDatabaseRecordField = Mid(s, U_SquadIndex + 1, LU_SquadIndex)
Case U_ScoreIndex: GetUserDatabaseRecordField = Mid(s, U_ScoreIndex + 1, LU_ScoreIndex)
Case U_Banner: GetUserDatabaseRecordField = Mid(s, U_Banner + 1, L_Banner)
Case U_CreateDateTime: GetUserDatabaseRecordField = Mid(s, U_CreateDateTime + 1, L_CreateDateTime)
Case U_IP: GetUserDatabaseRecordField = Mid(s, U_IP + 1, L_IP)
Case U_MacID: GetUserDatabaseRecordField = Mid(s, U_MacID + 1, L_MacID)
Case U_LastDatePlayed: GetUserDatabaseRecordField = Mid(s, U_LastDatePlayed + 1, L_LastDatePlayed)
Case U_TotalSeconds: GetUserDatabaseRecordField = Mid(s, U_TotalSeconds + 1, LU_TotalSeconds)
End Select
End Function

Public Sub PutUserDatabaseRecordField(ServerIndex As Long, UserDatabaseIndex As Long, Field As Integer, FieldValue As String)
Dim s As String
s = GetUserDatabaseRecord(ServerIndex, UserDatabaseIndex)
Select Case Field
Case U_Name: s = FillZero(FieldValue, L_Name) + Mid(s, U_Name + L_Name + 1)
Case U_SquadIndex: s = Left(s, U_SquadIndex) + FieldValue + Mid(s, U_SquadIndex + LU_SquadIndex + 1)
Case U_ScoreIndex: s = Left(s, U_ScoreIndex) + FieldValue + Mid(s, U_ScoreIndex + LU_ScoreIndex + 1)
Case U_Banner: s = Left(s, U_Banner) + FieldValue + Mid(s, U_Banner + L_Banner + 1)
Case U_CreateDateTime: s = Left(s, U_CreateDateTime) + FieldValue + Mid(s, U_CreateDateTime + L_CreateDateTime + 1)
Case U_IP: s = Left(s, U_IP) + FieldValue + Mid(s, U_IP + L_IP + 1)
Case U_MacID: s = Left(s, U_MacID) + FieldValue + Mid(s, U_MacID + L_MacID + 1)
Case U_LastDatePlayed: s = Left(s, U_LastDatePlayed) + FieldValue + Mid(s, U_LastDatePlayed + L_LastDatePlayed + 1)
Case U_TotalSeconds: s = Left(s, U_TotalSeconds) + FieldValue + Mid(s, U_TotalSeconds + LU_TotalSeconds + 1)
End Select
PutUserDatabaseRecord ServerIndex, UserDatabaseIndex, s
End Sub
